#ifndef ___IMC_DRIVER___REGISTRY_INDEXES_H___
#define ___IMC_DRIVER___REGISTRY_INDEXES_H___

namespace imc_driver
{
	const uint16 PROFILE_ACCELERATION_IDX = 0x6083;
	const uint8 PROFILE_ACCELERATION_SUB = 0x00;

	const uint16 PROFILE_DECELERATION_IDX = 0x6084;
	const uint8 PROFILE_DECELERATION_SUB = 0X00;

	const uint16 MAX_ACCELERATION_IDX = 0x60C5;
	const uint8 MAX_ACCELERATION_SUB = 0X00;

	const uint16 MAX_DECELERATION_IDX = 0x60C6;
	const uint8 MAX_DECELERATION_SUB = 0X00;

	const uint16 PROFILE_VELOCITY_IDX = 0x6081;
	const uint8 PROFILE_VELOCITY_SUB = 0X00;

	const uint16 MAX_PROFILE_VELOCITY_IDX = 0x607F;
	const uint8 MAX_PROFILE_VELOCITY_SUB = 0X00;

	const uint16 DRIVE_NAME_IDX = 0x2FFE;
	const uint8 DRIVE_NAME_SUB = 0X00;

	const uint16 POSITION_CONTROL_KP_IDX = 0x2500;
	const uint8 POSITION_CONTROL_KP_SUB = 0x01;
	const uint16 POSITION_CONTROL_KI_IDX = 0x2500;
	const uint8 POSITION_CONTROL_KI_SUB = 0x02;
	const uint16 POSITION_CONTROL_KD_IDX = 0x2500;
	const uint8 POSITION_CONTROL_KD_SUB = 0x03;

	const uint16 VELOCITY_CONTROL_KP_IDX = 0x2501;
	const uint8 VELOCITY_CONTROL_KP_SUB = 0x01;
	const uint16 VELOCITY_CONTROL_KI_IDX = 0x2501;
	const uint8 VELOCITY_CONTROL_KI_SUB = 0x02;
	const uint16 VELOCITY_CONTROL_KD_IDX = 0x2501;
	const uint8 VELOCITY_CONTROL_KD_SUB = 0x03;

	const uint16 MAX_CURRENT_IDX = 0x6073;
	const uint8 MAX_CURRENT_SUB = 0X00;

	const uint16 MAX_MOTOR_SPEED_IDX = 0x6080;
	const uint8 MAX_MOTOR_SPEED_SUB = 0X00;

	const uint16 QUICK_STOP_OPTION_IDX = 0x605A;
	const uint8 QUICK_STOP_OPTION_SUB = 0X00;

	const uint16 POSITIONING_RELATIVE_OPTION_IDX = 0x60F2;
	const uint8 POSITIONING_RELATIVE_OPTION_SUB = 0X00;
	const uint16 POSITIONING_ROTARY_AXIS_OPTION_IDX = 0x60F2; // same is correct
	const uint8 POSITIONING_ROTARY_AXIS_OPTION_SUB = 0X00;

	const uint16 MIN_POSITION_RANGE_LIMIT_IDX = 0x607D;
	const uint8 MIN_POSITION_RANGE_LIMIT_SUB = 0X01;
	const uint16 MAX_POSITION_RANGE_LIMIT_IDX = 0x607D;
	const uint8 MAX_POSITION_RANGE_LIMIT_SUB = 0X02;

	const uint16 SUPPORTED_DRIVE_MODES_IDX = 0x6502;
	const uint8 SUPPORTED_DRIVE_MODES_SUB = 0X00;

	const uint16 ERROR_REGISTER_IDX = 0x1001;
	const uint8 ERROR_REGISTER_SUB = 0x00;

	const uint16 HISTORY_NUMBER_OF_ERRORS_IDX = 0x1003;
	const uint8 HISTORY_NUMBER_OF_ERRORS_SUB = 0X00;
	const uint16 HISTORY_ERRORS_IDX = 0x1003;
	const uint8 HISTORY_ERRORS_SUB = 0X01;

	const uint16 IDENTITY_VENDOR_ID_IDX = 0x1018;
	const uint8 IDENTITY_VENDOR_ID_SUB = 0X01;
	const uint16 IDENTITY_PRODUCT_CODE_IDX = 0x1018;
	const uint8 IDENTITY_PRODUCT_CODE_SUB = 0X02;
	const uint16 IDENTITY_REVISION_NUMBER_IDX = 0x1018;
	const uint8 IDENTITY_REVISION_NUMBER_SUB = 0X03;
	const uint16 IDENTITY_SERIAL_NUMBER_IDX = 0x1018;
	const uint8 IDENTITY_SERIAL_NUMBER_SUB = 0X04;

	const uint16 MOTOR_TYPE_IDX = 0x6402;
	const uint8 MOTOR_TYPE_SUB = 0X00;

	const uint16 POSITION_DEMAND_VALUE_IDX = 0x60FC;
	const uint8 POSITION_DEMAND_VALUE_SUB = 0X00;

	const uint16 MANUFACTURER_DEVICE_NAME_IDX = 0x1008;
	const uint8 MANUFACTURER_DEVICE_NAME_SUB = 0X00;

	const uint16 MANUFACTURER_HARDWARE_NAME_IDX = 0x1009;
	const uint8 MANUFACTURER_HARDWARE_NAME_SUB = 0X00;

	const uint16 SOFTWARE_VERSION_IDX = 0x100A;
	const uint8 SOFTWARE_VERSION_SUB = 0X00;

	const uint16 HTTP_DRIVE_CATALOG_ADDRESS_IDX = 0x6505;
	const uint8 HTTP_DRIVE_CATALOG_ADDRESS_SUB = 0X00;

	const uint16 COMMAND_REFERENCE_SOURCE_IDX = 0x2430;
	const uint8 COMMAND_REFERENCE_SOURCE_SUB = 0X00;

	const uint16 ENCODER_INCREMENTS_IDX = 0x608F;
	const uint8 ENCODER_INCREMENTS_SUB = 0x01;
	const uint16 MOTOR_REVOLUTIONS_IDX = 0x608F;
	const uint8 MOTOR_REVOLUTIONS_SUB = 0x02;

	const uint16 MOTOR_RATED_CURRENT_IDX = 0x6075;
	const uint8 MOTOR_RATED_CURRENT_SUB = 0x00;

	const uint16 MOTOR_RATED_TORQUE_IDX = 0x6076;
	const uint8 MOTOR_RATED_TORQUE_SUB = 0x00;
}

#endif
